// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "BoBTweak.h"
#include "DlgProxy.h"
#include "BoBTweakDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakDlgAutoProxy

IMPLEMENT_DYNCREATE(CBoBTweakDlgAutoProxy, CCmdTarget)

CBoBTweakDlgAutoProxy::CBoBTweakDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CBoBTweakDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CBoBTweakDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CBoBTweakDlgAutoProxy::~CBoBTweakDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	AfxOleUnlockApp();
}

void CBoBTweakDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CBoBTweakDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CBoBTweakDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CBoBTweakDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CBoBTweakDlgAutoProxy)
	DISP_FUNCTION(CBoBTweakDlgAutoProxy, "Communicate", Communicate, VT_BOOL, VTS_PVARIANT VTS_PVARIANT)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IBoBTweak to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {12DD6744-FFBC-11D2-919B-B0B50EC10000}
static const IID IID_IBoBTweak =
{ 0x12dd6744, 0xffbc, 0x11d2, { 0x91, 0x9b, 0xb0, 0xb5, 0xe, 0xc1, 0x0, 0x0 } };

BEGIN_INTERFACE_MAP(CBoBTweakDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CBoBTweakDlgAutoProxy, IID_IBoBTweak, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {12DD6742-FFBC-11D2-919B-B0B50EC10000}
IMPLEMENT_OLECREATE2(CBoBTweakDlgAutoProxy, "BoBTweak.Application", 0x12dd6742, 0xffbc, 0x11d2, 0x91, 0x9b, 0xb0, 0xb5, 0xe, 0xc1, 0x0, 0x0)

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakDlgAutoProxy message handlers

BOOL CBoBTweakDlgAutoProxy::Communicate(VARIANT FAR* pVariant1, VARIANT FAR* pVariant2) 
{
	WORD wNotification;
	BYTE nData;

	wNotification = pVariant1->lVal & 0xffff;
	nData = (pVariant1->lVal >> 16) & 0xff;

	switch (wNotification)
	{
		case 0x0101:
			// close
			m_pDialog->EndDialog(IDOK);
			break;

		case 0x0201:
			// bring to top
			m_pDialog->BringWindowToTop();
			break;

		case 0x0301:
			// your id is (AppID)
			m_pDialog->m_nAppID = nData;
			break;

		case 0x0602:
			// subject changed
			break;

		case 0x0702:
			// subject renamed
			break;

		case 0x0802:
			// subject died
			break;

		case 0x0902:
			// subject aged
			break;

		case 0x0a02:
			// pause game (PauseState)
			break;
	}

	return TRUE;
}
